stages:
  - docker-layer-caching
  - docker

default:
  # Version needs to  be pinned but updated over time
  # https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#use-docker-in-docker
  image: docker:24.0.5
  services:
    - docker:24.0.5-dind
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

variables:
  # Use TLS https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#tls-enabled
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: "/certs"
  # enable when debugging: https://docs.gitlab.com/ee/ci/variables/#enable-debug-logging
  # perhaps security risk?
  # CI_DEBUG_TRACE: "true"


# https://docs.gitlab.com/ee/ci/docker/docker_layer_caching.html
# https://docs.gitlab.com/ee/user/packages/container_registry/build_and_push_images.html
.template/docker-layer-caching:
  stage: docker-layer-caching
  script:
    - FULL_DOCKER_NAME="${CI_REGISTRY_IMAGE}/${DOCKER_IMAGE_NAME}"
    - DOCKER_FILE="${DOCKER_IMAGE_NAME}.Dockerfile"
    - docker pull $FULL_DOCKER_NAME || true
    - docker build --cache-from $FULL_DOCKER_NAME --tag $FULL_DOCKER_NAME --file $DOCKER_FILE .
    - docker push $FULL_DOCKER_NAME

build/manylinux:
  variables:
     DOCKER_IMAGE_NAME: build-manylinux
  extends:
    - .template/docker-layer-caching

build/debian-debug:
  variables:
    DOCKER_IMAGE_NAME: build-debian-debug
  extends:
    - .template/docker-layer-caching

build/debian-conda:
  variables:
    DOCKER_IMAGE_NAME: build-debian-conda
  extends:
    - .template/docker-layer-caching

docs/debian-pdf:
  variables:
    DOCKER_IMAGE_NAME: docs-pdf
  extends:
    - .template/docker-layer-caching
